csect open1
      subroutine open1
      parameter (nperm=6,nscr=7,nscr1=5,nold=2,largon=100)
      parameter (npermd=nperm-nold)
c     next parameters need to be the same in iopt.f and open2.f 
      parameter (nguard=4,noptm=5)
      common /opciones/ optgs(noptm)
      character*8 optgs
      common /filens/ files(nguard)
      common /TAPES/ iunisa(14)
        character*6 identi(14) 
      character*1 bardir
      character*2 pre
      character*100 argum,files,filew,filen,homed
c     if arguments are longer they get truncated
      dimension indp(nperm),indfip(nperm),inds(nscr)
      character*4 exten(nperm)
      character*7 stats(nperm), stat
      integer code
      data optgs /'help','version','modellib','outdir',''/
      data bardir /'/'/
      data pre /'./'/ 
c     data iunis: argum(1) 51;modellib.dat; 9
c                 $1 means argum(3)
c                 $1.ls1 16; $1.ini 82; $1.for 81; $1.acs 11
      data iunisa / 16,      51,      9,       1,       4,       81 
     * ,82,      18,      3,       0,       10,      11,      13
     *     ,14/
      data identi /'iqqout','iqqinp','iqqlbm','iqqlbt','iqqutl','iqqpgm'
     *,'iqqdat','iqqpch','iqqutb','iqqmdl','iqqltr','iqqact','iqqtmp'
     *    ,'iqqbin'/

      data exten /'',    '',    '.ls1','.for','.ini','.acs'/
      data indp / 2,     3,     1,     6,     7,     12/
      data indfip /1,    2,     3,     3,     3,     3 /
      data stats /nold*'old    ',npermd*'unknown'/
c     dataiunise: iqqlbt,iqqutl,iqqutb,iqqpch,iqqltr,iqqtmp,iqqbin
      data inds / 4,      5,     9,     8,     11,    13,     14/
      data files /nguard*''/

c     ANALIZE OPTIONS AND ARGUM TO GET files
c           files(1): name of input file without .d
c           files(2); name of modellib.dat
c           files(3): outdir                
c     option -m indicates that  next "is" modellib.dat;
c         goes to files(2)
c     option -o indicates that next is outputdir 
c     argum is name of input file with or withot .d;
c           with dir part if necessary
c     1 argument needed; 4 possible options: help version modellib outdir;
C         with -- or - for just first letter
c     2 first options dont need a value; 2 last  options ... stop

      code=iopt(1,4,2,2)
      if (code. eq. 1) then
          call help1
      else if (code .eq. 2) then
          call vers
      else if (code .gt. 2) then
          call stop1(5)
          stop 206
      end if

      if (files(2).eq.'') then
          call getenv('HOME',homed)
          largoh=lenoc(homed)
          files(2)(1:largoh)=homed(1:largoh)
          files(2)(largoh+1:)='/lib/modellib.dat'
      endif
      largo2=lenoc(files(2))
      print *,'model file: ',files(2)(1:largo2)  

      largo1=lenoc(files(1))
      argum= files(1)
      if((largo1 .gt. 2) .and. (argum(largo1-1:largo1) .eq. '.d')) 
     *    argum=argum(1:largo1-2)
      largo1=lenoc(argum)
      files(1)(1:largo1)=argum
      files(1)(largo1+1:largo1+2)='.d'
      do 20, i=largo1,1,-1
          if(argum(i:i) .eq. bardir) go to 30
 20   continue
      i=0
 30   if (i .eq. largo1) then
         print *,'OPEN1: files(1) ',files(1)
     *, 'is not good for input file name'
         call stop1(5)
         stop 207
      else 
         if ((files(1)(1:1) .ne. bardir) .and. (files(1)(1:1) .ne. '.'))
     *   then
            files(1)(3:largon) = files(1)(1:largon-2)
            files(1)(1:2) = pre
         end if
         largo1 = lenoc(files(1))
         print *,'Input file: ',files(1)(1:largo1)
      end if
      argum=argum(i+1:)
      if ((files(3) .ne. '') .and. (files(3) .ne. '.')
     *     .and. (files(3) .ne. './')) then
          largo3=lenoc(files(3))
          if (files(3)(largo3:largo3) .ne. bardir)then
              files(3)(largo3+1:largo3+1)=bardir
              largo3=lenoc(files(3))
          end if
          filew(1:largo3)=files(3)
          filew(largo3+1:)=argum
      else
          filew(1:1)='.'
          filew(2:2)=bardir
          filew(3:)=argum
      end if
      largo3=lenoc(filew)
      print *,'Generic name of output files: ',filew(1:largo3)
      files(3)=filew

      do 50,i=1,nperm
          filen=files(indfip(i))
          largo=lenoc(filen)
          filen(largo+1:largo+4)=exten(i)
          iunit=iunisa(indp(i))
c          print *, i,indp(i),identi(indp(i)),' ',iunit,filen,stat
          stat = stats(i)
          open (unit=iunit,err=900,iostat=iostat,
     *          file=filen,
     *          status=stat)
          rewind iunit
 50   continue    
c     need filen without dir part to create new files in work dir

      filen='scratch'
      stat='scratch'
      do 200, i=1,nscr1
          iunit=iunisa(inds(i)) 
c          print *, i,inds(i),identi(inds(i)),' ',iunit,filen,stat
          open(unit=iunit,err=900,iostat=iostat,status=stat)
          rewind iunit
 200  continue    

      filen='scratch_unformatted'
      do 300, i=nscr1+1,nscr
          iunit=iunisa(inds(i)) 
c          print *, i,inds(i),identi(inds(i)),' ',iunit,filen,stat
          open (unit=iunit,err=900,iostat=iostat,
     *             form='unformatted',status=stat)
          rewind iunit
 300  continue

 450  format(6x,A)
 460  format(6x,A,'''',A,'''')
 470  format(5x,A,'''',A,'''',A)
      write(81,450)'subroutine source'
      write(81,450)'common /archid/name(2),gener(2)'
      write(81,450)'character*50 name,gener'
      write(81,460)'data name /',files(1)(1:50) 
      write(81,470)'*,',files(1)(51:100),'/'
      write(81,460)'data gener /',filew(1:50) 
      write(81,470)'*,',filew(51:100),'/'
      write(81,450)'return'
      write(81,450)'end'
 
      return

 900  largo=lenoc(filen)
      print *,'OPEN1: open error - file: ',filen(1:largo) 
      print *,'                  - unit: ',iunit
      print *,'                  - stat: ',stat
      print *,'                  - iostat: ',iostat      
      print *, filen(1:largo),' could not be opened'
c 950 format(1x,15a7)
c 960 format(6x,15i7)
c     print 950, ' identi ',identi
c     print 960, iunisa
      call stop1(5)
      stop 208
      end
